import ply.yacc as yacc
from WAELexer import tokens

def p_waeStart(p):
  'waeStart : wae SEMI'
  p[0] = p[1]

def p_wae_1(p):
  'wae : NUMBER' 
  p[0] = True

def p_wae_2(p):
  'wae : ID' 
  p[0] = True

def p_wae_3(p):
  'wae : LBRACE PLUS wae wae RBRACE' 
  p[0] = True if p[3] and p[4] else False

def p_wae_4(p):
  'wae : LBRACE MINUS wae wae RBRACE' 
  p[0] = True if p[3] and p[4] else False

def p_wae_5(p):
  'wae : LBRACE TIMES wae wae RBRACE' 
  p[0] = True if p[3] and p[4] else False

def p_wae_6(p):
  'wae : LBRACE DIV wae wae RBRACE' 
  p[0] = True if p[3] and p[4] else False

def p_wae_7(p):
  'wae : LBRACE IF wae wae wae RBRACE'
  p[0] = True if p[3] and p[4] and p[5] else False

def p_wae_8(p):
  'wae : LBRACE WITH LBRACE alist RBRACE wae RBRACE'
  p[0] = True if len(p[4]) == len(set(p[4])) else False

def p_alist_1(p):
  'alist : LBRACE ID wae RBRACE'
  p[0] = [p[2]]

def p_alist_2(p):
  'alist : LBRACE ID wae RBRACE alist'
  p[0] = p[5] + [p[2]]

def p_error(p):
  print("Syntax error in input!")

parser = yacc.yacc()

