import sys
import ply.yacc as yacc
from JSONLexer import tokens

def p_jsonStart(p):
  'jsonStart : json SEMI'
  p[0] = True

def p_json_1(p):
  'json : STRING'

def p_json_2(p):
  'json : NUMBER'

def p_json_3(p):
  'json : LBRACE keyvals RBRACE'

def p_json_4(p):
  'json : LBRACKET vals RBRACKET'

def p_keyvals_1(p):
  'keyvals : STRING COLON json'

def p_keyvals_2(p):
  'keyvals : keyvals COMMA STRING COLON json'

def p_vals_1(p):
  'vals : json'

def p_vals_2(p):
  'vals : vals COMMA json'

def p_error(p):
  print("Syntax error in input!")
  raise SyntaxError

parser = yacc.yacc()
